<template>
  <div class="control-panel">
    <div class="control-panel__header">
      <div class="expand-toggle" @click="expanded = !expanded">Породы  <icon-chevron :style="chevronStyles" /></div>
      <div class="control-panel__right-side">
        <slot name="right"></slot>
      </div>
    </div>
    <div class="control-panel__body" :class="{'control-panel__body--expanded': expanded}">
      <div class="selected-breeds">
        <div class="breed-item breed-item--active">
          <div v-if="$route.params.slug" class="breed-item__name">{{$route.params.slug}}</div>
          <div v-else class="breed-item__name">Все пёсели</div>
        </div>
      </div>
      <template v-for="(item, letter) in items">
         <div class="breed-letter" :key="letter">{{letter}}</div>
         <router-link :to="breedRoute(breed)" class="breed-item" v-for="(breed, index) in item.children" :key="`${letter}-${index}`" >
          <div class="breed-item__name">{{breed}}</div>
        </router-link>
      </template>
    </div>
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import IconChevron from './icons/IconChevron'
export default {
  components: { IconChevron },
  data () {
    return {
      expanded: false
    }
  },
  watch: {
    $route: {
      deep: true,
      handler () {
        this.expanded = false
      }
    }
  },
  computed: {
    ...mapGetters(['getBreeds']),
    items () {
      const data = this.getBreeds.reduce((r, e) => {
        const group = e[0]
        if (!r[group]) {
          r[group] = { group, children: [e] }
        } else {
          r[group].children.push(e)
        }
        return r
      }, {})
      return data
    },
    chevronStyles () {
      const obj = {}
      if (this.expanded) {
        obj.transform = 'rotate(180deg)'
      }
      return obj
    }
  },
  methods: {
    ...mapActions(['fetchBreeds']),
    breedRoute (breed) {
      return { name: 'Breed', params: { slug: breed.replace(' ', '-') } }
    }
  },
  mounted () {
    this.fetchBreeds()
  }
}
</script>

<style lang="scss">
.expand-toggle {
     font-size: 16px;
    line-height: 20px;
    cursor: pointer;
    display: flex;
    align-items: center;
    width: 83px;
    padding-bottom: 2px;
    border-bottom: 1px dashed #fff;
}
.control-panel {
  margin: 55px 0;
  &__header {
    display: flex;
    justify-content: space-between;
  }

  &__body {
    display: none;
    margin-top: 10px;
    flex-wrap: wrap;
    &--expanded {
      display: flex !important;
    }
    > div, a {
      margin: 10px 15px 10px 0;
    }
    > div:first-child {
      margin-left: 0;
    }
  }
  &__right-side {

    > * {
       display: flex;
      align-items: center;
      cursor: pointer;
      font-size: 16px;
      line-height: 28px;
      /* identical to box height, or 175% */

      text-align: right;
      letter-spacing: 0.01em;

      color: #626262;
    }
  }
}
.breed-letter {
  display: flex;
  align-items: center;
  font-size: 20px;
  line-height: 28px;
  /* identical to box height, or 140% */

  letter-spacing: 0.01em;

  color: #626262;
  text-transform: uppercase;
}
.breed-item {
  color: #626262;
  display: flex;
  border-radius: 20px;
  border: 1px solid #626262;
  padding: 4px 12px;
  text-transform: capitalize;
  text-decoration: none;
  height: 24px;
  align-items: center;

  &__name {
    font-size: 12px;
    line-height: 16px;
    /* identical to box height, or 133% */

    letter-spacing: 0.01em;

  cursor: pointer;
  }
  &--active, &:hover {
    color: #3C59F0;
    border-color: #3C59F0;

  }
}
svg.icon-chevron {
  margin-left: 10px;
}
.selected-breeds {
  display: flex;
  width: 100%;
}
.icon-toggle {
  margin-left: 10px;
}
</style>
